# Contributing to Elmo!
First off, thanks for taking the time to contribute! You are awesome.

The following is a set of guidelines for contributing to Elmo!

### Table of Contents
* [Code of Conduct](#code-of-conduct)
* [What should I know before I get started?](#what-should-i-know-before-i-get-started?)
* [How Can I Contribute?](#how-can-i-contribute?)
  * [Reporting bugs](#reporting-bugs)
  * [Pull Requests](#pull-requests)
* [Styleguides](#styleguides)
  * [Git Commit Messages](#git-commit-messages)
  * [Documentation](#documentation)

## Code of Conduct
This project and everyone participating in it is governed by the [Elmo Code of Conduct](https://github.com/lap00zza/elmo/blob/master/CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Please report unacceptable behavior to jewelmahant@gmail.com. 

## What should I know before I get started?
Elmo aims to simplify the use of the DOM API without adding the overhead of big libraries. The focus is mainly on easy to read code that can be followed by anyone.

## How Can I Contribute?
### Reporting bugs
Before reporting a bug, please do a quick search in our [Issue Tracker](https://github.com/lap00zza/elmo/issues). If there are no duplicates then file a new issue. Be sure to include a proper description and steps to reproduce the issue.

### Suggestion enhancements
Before suggesting an enhancement, please do a quick search in our [Issue Tracker](https://github.com/lap00zza/elmo/issues). If there are no duplicates then file a new issue and prefix `Enhancement:` or `Suggestion:` on the title. Be sure to include a proper description as well.

### Pull Requests
* Do not include issue numbers in the PR title.
* Be sure to document your code. Without proper documentation your PR won't be accepted.
* Describe what your code does in the PR. A proper description is a must.
* End all files with a newline.

## Styleguides
#### Git Commit Messages
[Angular JS Commit Guide](https://github.com/angular/angular.js/blob/master/CONTRIBUTING.md#commit)
#### Documentation
[JSDoc](http://usejsdoc.org/)
#### Javascript
[StandardJS](http://standardjs.com)
